
-- Initialize the variables
local _CurrentRealm = GetRealmName();
local _CurrentPlayerName = UnitName("player");

--[[
CharRecords = {};
CharRecords[Server] = {};
CharRecords[Server][CurrentPlayerName] = {};


Inventory = {};
Inventory[Server] = {};
Inventory[Server][CurrentPlayerName] = {};
]]--

function Banker_OnLoad()

	BankerFrame:RegisterEvent("BANKFRAME_CLOSED");
	BankerFrame:RegisterEvent("BANKFRAME_OPENED");

	BankerFrame:RegisterEvent("PLAYER_LOGOUT");

	BankerFrame:RegisterEvent("MAIL_CLOSED");
	BankerFrame:RegisterEvent("MAIL_SHOW");
	
	if not Inventory then
		Inventory = {}
	end
	initTable(Inventory,_CurrentRealm,_CurrentPlayerName,"Inventory")
	initTable(Inventory,_CurrentRealm,_CurrentPlayerName,"Time")
    
	Inventory[_CurrentRealm][_CurrentPlayerName]["Time"]["OnLoad"] = time();

	BankerLoadTime = GetTime()
end



function Banker_OnEvent(self,event,...)

	recordTimeOfEvent(event)
	
	if "BANKFRAME_OPENED"==event then
		local toi = TableOfInventory()
		
		if not Inventory then
			Inventory = {}
		end
		initTable(Inventory,_CurrentRealm,_CurrentPlayerName,"Inventory")
		initTable(Inventory,_CurrentRealm,_CurrentPlayerName,"Time")
		
		Inventory[_CurrentRealm][_CurrentPlayerName]["Inventory"] = toi;
		Inventory[_CurrentRealm][_CurrentPlayerName]["Time"]["Updated"] = time();
		
		local size = tablelength(toi)
		
		print("Banker Updated: " .. ColorText(255,102,00) .. size .. ColorText() );
		
	end
	
end

local eventIdNumber = 0

function recordTimeOfEvent(event)

	local Server = GetRealmName();
	local CurrentPlayerName = UnitName("player");

	if not CharRecords then
		CharRecords = {};
	end
	
	if not CharRecords[Server] then
		CharRecords[Server] = {};
	end
	
	if not CharRecords[Server][CurrentPlayerName] then
		CharRecords[Server][CurrentPlayerName] = {};
	end
	
	if not CharRecords[Server][CurrentPlayerName][event] then
		CharRecords[Server][CurrentPlayerName][event] = {};
	end
	
	CharRecords[Server][CurrentPlayerName][event]["GetTime"] = GetTime();
	CharRecords[Server][CurrentPlayerName][event]["time"] = time();
	
	CharRecords[Server][CurrentPlayerName][event]["eventIdNumber"] = eventIdNumber;

	eventIdNumber = eventIdNumber + 1
end


function Banker_OnUpdate()

end




SLASH_BANKERADDON_SEARCH1 = '/banker';
function SlashCmdList.BANKERADDON_SEARCH(msg, editbox) 
	BankerSlashHandler(msg,editbox,"BANKER")
end


function BankerSlashHandler(msg,editbox,source)

	msg = trim(msg)
	
	local lmsg = string.lower(msg)
	
	if string.len(msg)<=1 or lmsg=="help" or lmsg=="?" then
	
		print("Use "..ColorText(1,0,0).."/banker cloth]"..ColorText().." to search for various cloths")
	
	else
        SendAddonMessage("_BankerSearch", msg, "GUILD")
		BankerBasicSearch(msg)

	end
	
end



function BankerBasicSearch(itemName)

	local lmsg = string.lower(itemName)

	print("Searching for: " .. ColorText(255,102,0) .. itemName)
	
	local lastPrintedCharName = ""

	for k1, v1 in pairs(Inventory[_CurrentRealm]) do
	
		local charName = k1
	
		for k2, v2 in pairs(v1["Inventory"]) do
		
			local loc = k2
			local count = v2["count"]
			local link = v2["itemLink"]
			local id = v2["itemId"]
			
			local llink = string.lower(link)
			
            local matchAll = true
            
            for keyword in string.gmatch(lmsg, "%S+") do
                if not string.find(llink,keyword,1,true) then
                    matchAll = false
                end
            end
            
			if matchAll then
				if lastPrintedCharName ~= charName then
					print(ColorText(1,0,1) .. charName)
					lastPrintedCharName = charName
				end
			
				print("   " .. link .. "  " .. ColorText(0,1,0) .. count)
			end
		
		end
	
	end

end

